---FortschrittT174
--Doxerv
--2009/11/04


FortschrittT174 = {}

function FortschrittT174.prerequisitesPresent(specializations)
    Vehicle.registerJointType("frontloader");
    return SpecializationUtil.hasSpecialization(Steerable, specializations);
end;

function FortschrittT174:load(xmlFile)
    
    self.controlpath = Utils.getFilename("textur/Fortschritt_T_174_hud.png", self.baseDirectory);
    self.hudFortschrittT174PoxX = 0.01;
    self.hudFortschrittT174PoxY = 1-0.204;
    self.hudFortschrittT174Width = 0.360;
    self.hudFortschrittT174Height = 0.360;
    self.hudFortschrittT174PoxX = 0.0;
    self.hudFortschrittT174PoxY = 0.45
    self.hudFortschrittT174Overlay = Overlay:new("hudFortschritt_T_174_hud.png", self.controlpath, self.hudFortschrittT174PoxX, self.hudFortschrittT174PoxY, self.hudFortschrittT174Width, self.hudFortschrittT174Height);
	
	self.rundumleuchtenAnz = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.rundumleuchten#count"),0);
    self.rundumleuchtenKey = getXMLString(xmlFile, "vehicle.rundumleuchten#key");
    self.rundumleuchtenAn = false;
    self.rundumleuchten = {};
    for i=1, self.rundumleuchtenAnz do
        local objname = string.format("vehicle.rundumleuchten.light" .. "%d",i);
        self.rundumleuchten[i] = {};
        self.rundumleuchten[i].rotNode = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, objname .. "#rotNode"));
        self.rundumleuchten[i].light = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, objname .. "#light"));
        self.rundumleuchten[i].source = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, objname .. "#lightsource"));
        self.rundumleuchten[i].speed = Utils.getNoNil(getXMLInt(xmlFile,  objname .. "#rotSpeed"), 1)/1000;
        self.rundumleuchten[i].emit = Utils.getNoNil(getXMLBool(xmlFile, objname .. "#emitLight"), true);
        if not self.rundumleuchten[i].emit and self.rundumleuchten[i].source ~= nil then
           setVisibility(self.rundumleuchten[i].source, false);
        end;
    end;
	
	local motorMinRpm = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.motor#minRpm"), 1000);
    local motorMaxRpmStr = getXMLString(xmlFile, "vehicle.motor#maxRpm");
    local motorMaxRpm1, motorMaxRpm2, motorMaxRpm3 = Utils.getVectorFromString(motorMaxRpmStr);
    motorMaxRpm1 = Utils.getNoNil(motorMaxRpm1, 800);
    motorMaxRpm2 = Utils.getNoNil(motorMaxRpm2, 1000);
    motorMaxRpm3 = Utils.getNoNil(motorMaxRpm3, 1800);
    local motorMaxRpm = {motorMaxRpm1, motorMaxRpm2, motorMaxRpm3};
    self.motorMaxRpmLimit = motorMaxRpm;
	
	 self.exhaustParticleSystems = {};
      local exhaustParticleSystemCount = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.exhaustParticleSystems#count"), 0);
	for i=1, exhaustParticleSystemCount do
      	local namei = string.format("vehicle.exhaustParticleSystems.exhaustParticleSystem%d", i);
		local nodei = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, namei .. "#index"));
      	Utils.loadParticleSystem(xmlFile, self.exhaustParticleSystems, namei, nodei, false, nil, self.baseDirectory);
	end;
	
	
	self.keys = {};
    local i=0;
    while true do
        local baseName = string.format("vehicle.keys.input(%d)", i);
        local inputName = getXMLString(xmlFile, baseName.. "#name");
        if inputName == nil then
            break;
        end;
        local inputKey = getXMLString(xmlFile, baseName.. "#key");
        if Input[inputKey] == nil then
            print("Error: invalid key '" .. inputKey .. "'  for input event '" .. inputName .. "'");
            break;
        end;
        self.keys[inputName] = Input[inputKey];
        i = i+1;
    end;
	
	local ajtoNode = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.ajto#index"));
    if ajtoNode ~= nil then
        self.ajto = {};
        self.ajto.node = ajtoNode;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.ajto#minRot"));
        self.ajto.minRot = {};
        self.ajto.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.ajto.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.ajto.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.ajto#maxRot"));
        self.ajto.maxRot = {};
        self.ajto.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.ajto.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.ajto.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.ajto.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.ajto#rotTime"), 2)*1000;
        self.ajto.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.ajto#touchRotLimit"), 10));
    end;
	
	local foegysegNode = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.foegyseg#index"));
    if foegysegNode ~= nil then
        self.foegyseg = {};
        self.foegyseg.node = foegysegNode;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.foegyseg#minRot"));
        self.foegyseg.minRot = {};
        self.foegyseg.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.foegyseg.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.foegyseg.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.foegyseg#maxRot"));
        self.foegyseg.maxRot = {};
        self.foegyseg.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.foegyseg.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.foegyseg.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.foegyseg.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.foegyseg#rotTime"), 2)*1000;
        self.foegyseg.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.foegyseg#touchRotLimit"), 10));
    end;
	
	local karNode = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.kar#index"));
    if karNode ~= nil then
        self.kar = {};
        self.kar.node = karNode;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.kar#minRot"));
        self.kar.minRot = {};
        self.kar.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.kar.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.kar.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.kar#maxRot"));
        self.kar.maxRot = {};
        self.kar.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.kar.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.kar.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.kar.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.kar#rotTime"), 2)*1000;
        self.kar.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.kar#touchRotLimit"), 10));
    end;
	
	local hydraulikaNode = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.hydraulika#index"));
    if hydraulikaNode ~= nil then
        self.hydraulika = {};
        self.hydraulika.node = hydraulikaNode;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.hydraulika#minRot"));
        self.hydraulika.minRot = {};
        self.hydraulika.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.hydraulika.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.hydraulika.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.hydraulika#maxRot"));
        self.hydraulika.maxRot = {};
        self.hydraulika.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.hydraulika.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.hydraulika.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.hydraulika.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.hydraulika#rotTime"), 2)*1000;
        self.hydraulika.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.hydraulika#touchRotLimit"), 10));
    end;
	
	local nyomorudNode = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.nyomorud#index"));
    if nyomorudNode ~= nil then
        self.nyomorud = {};
        self.nyomorud.node = nyomorudNode;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.nyomorud#minTrans"));
        self.nyomorud.minTrans = {};
        self.nyomorud.minTrans[1] = Utils.getNoNil(x, 0);
        self.nyomorud.minTrans[2] = Utils.getNoNil(y, 0);
        self.nyomorud.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.nyomorud#maxTrans"));
        self.nyomorud.maxTrans = {};
        self.nyomorud.maxTrans[1] = Utils.getNoNil(x, 0);
        self.nyomorud.maxTrans[2] = Utils.getNoNil(y, 0);
        self.nyomorud.maxTrans[3] = Utils.getNoNil(z, 0);

        self.nyomorud.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.nyomorud#transTime"), 2)*1000;
        self.nyomorud.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.nyomorud#touchTransLimit"), 10);
    end;
	
	local kar1Node = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.kar1#index"));
    if kar1Node ~= nil then
        self.kar1 = {};
        self.kar1.node = kar1Node;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.kar1#minRot"));
        self.kar1.minRot = {};
        self.kar1.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.kar1.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.kar1.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.kar1#maxRot"));
        self.kar1.maxRot = {};
        self.kar1.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.kar1.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.kar1.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.kar1.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.kar1#rotTime"), 2)*1000;
        self.kar1.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.kar1#touchRotLimit"), 10));
    end;
	
	local hydraulika1Node = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.hydraulika1#index"));
    if hydraulika1Node ~= nil then
        self.hydraulika1 = {};
        self.hydraulika1.node = hydraulika1Node;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.hydraulika1#minRot"));
        self.hydraulika1.minRot = {};
        self.hydraulika1.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.hydraulika1.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.hydraulika1.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.hydraulika1#maxRot"));
        self.hydraulika1.maxRot = {};
        self.hydraulika1.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.hydraulika1.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.hydraulika1.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.hydraulika1.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.hydraulika1#rotTime"), 2)*1000;
        self.hydraulika1.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.hydraulika1#touchRotLimit"), 10));
    end;
	
	local nyomorud1Node = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.nyomorud1#index"));
    if nyomorud1Node ~= nil then
        self.nyomorud1 = {};
        self.nyomorud1.node = nyomorud1Node;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.nyomorud1#minTrans"));
        self.nyomorud1.minTrans = {};
        self.nyomorud1.minTrans[1] = Utils.getNoNil(x, 0);
        self.nyomorud1.minTrans[2] = Utils.getNoNil(y, 0);
        self.nyomorud1.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.nyomorud1#maxTrans"));
        self.nyomorud1.maxTrans = {};
        self.nyomorud1.maxTrans[1] = Utils.getNoNil(x, 0);
        self.nyomorud1.maxTrans[2] = Utils.getNoNil(y, 0);
        self.nyomorud1.maxTrans[3] = Utils.getNoNil(z, 0);

        self.nyomorud1.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.nyomorud1#transTime"), 2)*1000;
        self.nyomorud1.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.nyomorud1#touchTransLimit"), 10);
    end;
	
	local kar2Node = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.kar2#index"));
    if kar2Node ~= nil then
        self.kar2 = {};
        self.kar2.node = kar2Node;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.kar2#minRot"));
        self.kar2.minRot = {};
        self.kar2.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.kar2.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.kar2.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.kar2#maxRot"));
        self.kar2.maxRot = {};
        self.kar2.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.kar2.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.kar2.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.kar2.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.kar2#rotTime"), 2)*1000;
        self.kar2.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.kar2#touchRotLimit"), 10));
    end;
	
	local csipeszNode = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.csipesz#index"));
    if csipeszNode ~= nil then
        self.csipesz = {};
        self.csipesz.node = csipeszNode;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.csipesz#minRot"));
        self.csipesz.minRot = {};
        self.csipesz.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.csipesz.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.csipesz.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.csipesz#maxRot"));
        self.csipesz.maxRot = {};
        self.csipesz.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.csipesz.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.csipesz.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.csipesz.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.csipesz#rotTime"), 2)*1000;
        self.csipesz.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.csipesz#touchRotLimit"), 10));
    end;
	
	local baltalpNode = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.baltalp#index"));
    if baltalpNode ~= nil then
        self.baltalp = {};
        self.baltalp.node = baltalpNode;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.baltalp#minRot"));
        self.baltalp.minRot = {};
        self.baltalp.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.baltalp.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.baltalp.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.baltalp#maxRot"));
        self.baltalp.maxRot = {};
        self.baltalp.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.baltalp.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.baltalp.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.baltalp.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.baltalp#rotTime"), 2)*1000;
        self.baltalp.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.baltalp#touchRotLimit"), 10));
    end;
	
	local talpNode = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.talp#index"));
    if talpNode ~= nil then
        self.talp = {};
        self.talp.node = talpNode;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.talp#minRot"));
        self.talp.minRot = {};
        self.talp.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.talp.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.talp.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.talp#maxRot"));
        self.talp.maxRot = {};
        self.talp.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.talp.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.talp.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.talp.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.talp#rotTime"), 2)*1000;
        self.talp.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.talp#touchRotLimit"), 10));
    end;
	
	local jobbtalpNode = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.jobbtalp#index"));
    if jobbtalpNode ~= nil then
        self.jobbtalp = {};
        self.jobbtalp.node = jobbtalpNode;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.jobbtalp#minRot"));
        self.jobbtalp.minRot = {};
        self.jobbtalp.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.jobbtalp.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.jobbtalp.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.jobbtalp#maxRot"));
        self.jobbtalp.maxRot = {};
        self.jobbtalp.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.jobbtalp.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.jobbtalp.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.jobbtalp.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.jobbtalp#rotTime"), 2)*1000;
        self.jobbtalp.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.jobbtalp#touchRotLimit"), 10));
    end;
	
	local talp1Node = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.talp1#index"));
    if talp1Node ~= nil then
        self.talp1 = {};
        self.talp1.node = talp1Node;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.talp1#minRot"));
        self.talp1.minRot = {};
        self.talp1.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.talp1.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.talp1.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.talp1#maxRot"));
        self.talp1.maxRot = {};
        self.talp1.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.talp1.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.talp1.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.talp1.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.talp1#rotTime"), 2)*1000;
        self.talp1.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.talp1#touchRotLimit"), 10));
    end;
	
	local nyomorud2Node = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.nyomorud2#index"));
    if nyomorud2Node ~= nil then
        self.nyomorud2 = {};
        self.nyomorud2.node = nyomorud2Node;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.nyomorud2#minTrans"));
        self.nyomorud2.minTrans = {};
        self.nyomorud2.minTrans[1] = Utils.getNoNil(x, 0);
        self.nyomorud2.minTrans[2] = Utils.getNoNil(y, 0);
        self.nyomorud2.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.nyomorud2#maxTrans"));
        self.nyomorud2.maxTrans = {};
        self.nyomorud2.maxTrans[1] = Utils.getNoNil(x, 0);
        self.nyomorud2.maxTrans[2] = Utils.getNoNil(y, 0);
        self.nyomorud2.maxTrans[3] = Utils.getNoNil(z, 0);

        self.nyomorud2.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.nyomorud2#transTime"), 2)*1000;
        self.nyomorud2.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.nyomorud2#touchTransLimit"), 10);
    end;
	
	self.IranyjelzoLampaBal = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.baliranyjelzo#index"));
    self.IranyjelzoLampaJobb = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.jobbiranyjelzo#index"));
	
    self.iranyjelzoLampaBalActive = false;
    self.iranyjelzoLampaJobb = false;
    self.iranyjelzo = false;
    self.iranyjelzoJobb = false;
    self.iranyjelzoBal = false;
    self.kesleltetesBeBal = 0;
    self.kesleltetesKiBal = 0;
    self.kesleltetesBeJobb = 0;
    self.kesleltetesKiJobb = 0;
    self.kesleltetesBe = 0;
    self.kesleltetesKi = 0;
    self.deltafo = 0;
    --iranyjelzoHangFile = Utils.getFilename("sounds/klick.wav", self.baseDirectory);
    --self.iranyjelzoHangId = createSample("iranyjelzoHang");
    --loadSample(self.iranyjelzoHangId, iranyjelzoHangFile, false);
    
	self.bcActive = false;
end;
      
function FortschrittT174:delete()
end;

function FortschrittT174:mouseEvent(posX, posY, isDown, isUp, button)
end;
	  
function FortschrittT174:keyEvent(unicode, sym, modifier, isDown)

    if isDown and sym == Input.KEY_o then
		self.bcActive = not self.bcActive;
    end;
    if isDown and sym == Input.KEY_5 then
		self.ajtoMax = not self.ajtoMax;
	end;
	if isDown and sym == Input.KEY_x then
		self.baltalpMax = not self.baltalpMax;
		self.talpMax = not self.talpMax;
	end;
	if isDown and sym == Input.KEY_z then
		self.jobbtalpMax = not self.jobbtalpMax;
		self.talp1Max = not self.talp1Max;
	end;
	if sym == Input.KEY_n then
		self.foegysegMax = isDown;
	end;
	if sym == Input.KEY_m then
		self.foegysegMin = isDown;
	end;
	if sym == Input.KEY_KP_9 then
		self.karMax = isDown;
		self.hydraulikaMax = isDown;
		self.nyomorudMax = isDown;
		self.nyomorud2Max = isDown;
	end;
	if sym == Input.KEY_KP_6 then
		self.karMin = isDown;
		self.hydraulikaMin = isDown;
		self.nyomorudMin = isDown;
		self.nyomorud2Min = isDown;
	end;
	if sym == Input.KEY_KP_8 then
		self.kar1Max = isDown;
		self.hydraulika1Max = isDown;
		self.nyomorud1Max = isDown;
	end;
	if sym == Input.KEY_KP_5 then
		self.kar1Min = isDown;
		self.hydraulika1Min = isDown;
		self.nyomorud1Min = isDown;
	end;	
	if sym == Input.KEY_KP_7 then
		self.kar2Max = isDown;
	end;
	if sym == Input.KEY_KP_4 then
		self.kar2Min = isDown;
	end;
	if sym == Input.KEY_KP_1 then
		self.csipeszMax = isDown;
	end;
	if sym == Input.KEY_KP_2 then
		self.csipeszMin = isDown;
	end;
	
	if isDown and sym == Input.KEY_5 then
		self.iranyjelzoBal = not self.iranyjelzoBal;
		self.kesleltetesBeBal = 10;
		self.iranyjelzoJobb = false;
		self.iranyjelzo = false;
		self.iranyjelzoLampaJobbActive = false;
	end;

	if isDown and sym == Input.KEY_7 then
		self.iranyjelzoJobb = not self.iranyjelzoJobb;
		self.kesleltetesBeJobb = 10;
		self.iranyjelzoBal = false;
		self.iranyjelzo = false;
		self.iranyjelzoLampaBalActive = false;
	end;
	if isDown and sym == Input.KEY_6 then
		self.iranyjelzo = not self.iranyjelzo;
		self.iranyjelzoJobb = false;
		self.iranyjelzoBal = false;
		self.kesleltetesBe = 20;
		self.iranyjelzoLampaJobbActive = false;
		self.iranyjelzoLampaBalActive = false;
	end;
	
	if self.isEntered then
      if self.rundumleuchtenKey ~= nil then
         if isDown and sym == Input[self.rundumleuchtenKey] then
           self.rundumleuchtenAn = not self.rundumleuchtenAn;
           for i=1, self.rundumleuchtenAnz do
             setVisibility(self.rundumleuchten[i].light, self.rundumleuchtenAn);
           end;
         end;
      end;
    end;

end;

function FortschrittT174:update(dt)

    if self:getIsActiveForInput() and self.isEntered then
	    if self.motor.speedLevel ~= 0 then
            if InputBinding.isPressed(InputBinding.ACCELERATE) then
		        if self.motor.maxRpm[self.motor.speedLevel] <= (self.motorMaxRpmLimit[3] - 10) then
		            self.motor.maxRpm[self.motor.speedLevel] = self.motor.maxRpm[self.motor.speedLevel] + 10;
			    end;
		    elseif InputBinding.isPressed(InputBinding.DECELERATE) then
		        if self.motor.maxRpm[self.motor.speedLevel] >= 10 then
			        self.motor.maxRpm[self.motor.speedLevel] = self.motor.maxRpm[self.motor.speedLevel] - 10;
			    end;
	    	end;
		else
            if InputBinding.isPressed(InputBinding.ACCELERATE) then
		        if self.motor.maxRpm[3] <= (self.motorMaxRpmLimit[3] - 10) then
		            self.motor.maxRpm[3] = self.motor.maxRpm[3] + 10;
			    end;
		    elseif InputBinding.isPressed(InputBinding.DECELERATE) then
		        if self.motor.maxRpm[3] >= 10 then
			        self.motor.maxRpm[3] = self.motor.maxRpm[3] - 10;
			    end;
	    	end;
		end;
	end;

	if self.ajto ~= nil then
        	local x, y, z = getRotation(self.ajto.node);
        	local rot = {x,y,z};
        	local newRot = Utils.getMovedLimitedValues(rot, self.ajto.maxRot, self.ajto.minRot, 3, self.ajto.rotTime, dt, not self.ajtoMax);
        	setRotation(self.ajto.node, unpack(newRot));
	end;
	
	local doRotate = self.foegysegMax or self.foegysegMin 
	if self.foegyseg ~= nil and doRotate then
        	local x, y, z = getRotation(self.foegyseg.node);
        	local rot = {x,y,z};
        	local newRot = Utils.getMovedLimitedValues(rot, self.foegyseg.maxRot, self.foegyseg.minRot, 3, self.foegyseg.rotTime, dt, not self.foegysegMax);
        	setRotation(self.foegyseg.node, unpack(newRot));
	end;
	
	local doRotate = self.karMax or self.karMin 
	if self.kar ~= nil and doRotate then
        	local x, y, z = getRotation(self.kar.node);
        	local rot = {x,y,z};
        	local newRot = Utils.getMovedLimitedValues(rot, self.kar.maxRot, self.kar.minRot, 3, self.kar.rotTime, dt, not self.karMax);
        	setRotation(self.kar.node, unpack(newRot));
	end;
	
	local doRotate = self.hydraulikaMax or self.hydraulikaMin 
	if self.hydraulika ~= nil and doRotate then
        	local x, y, z = getRotation(self.hydraulika.node);
        	local rot = {x,y,z};
        	local newRot = Utils.getMovedLimitedValues(rot, self.hydraulika.maxRot, self.hydraulika.minRot, 3, self.hydraulika.rotTime, dt, not self.hydraulikaMax);
        	setRotation(self.hydraulika.node, unpack(newRot));
	end;
	
	local doTranslate = self.nyomorudMax or self.nyomorudMin 
	if self.nyomorud ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.nyomorud.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.nyomorud.maxTrans, self.nyomorud.minTrans, 3, self.nyomorud.transTime, dt, not self.nyomorudMax); 
		setTranslation(self.nyomorud.node, unpack(newTrans)); 
	end;
	
	local doRotate = self.kar1Max or self.kar1Min 
	if self.kar1 ~= nil and doRotate then
        	local x, y, z = getRotation(self.kar1.node);
        	local rot = {x,y,z};
        	local newRot = Utils.getMovedLimitedValues(rot, self.kar1.maxRot, self.kar1.minRot, 3, self.kar1.rotTime, dt, not self.kar1Max);
        	setRotation(self.kar1.node, unpack(newRot));
	end;
	
	local doRotate = self.hydraulika1Max or self.hydraulika1Min 
	if self.hydraulika1 ~= nil and doRotate then
        	local x, y, z = getRotation(self.hydraulika1.node);
        	local rot = {x,y,z};
        	local newRot = Utils.getMovedLimitedValues(rot, self.hydraulika1.maxRot, self.hydraulika1.minRot, 3, self.hydraulika1.rotTime, dt, not self.hydraulika1Max);
        	setRotation(self.hydraulika1.node, unpack(newRot));
	end;
	
	local doTranslate = self.nyomorud1Max or self.nyomorud1Min 
	if self.nyomorud1 ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.nyomorud1.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.nyomorud1.maxTrans, self.nyomorud1.minTrans, 3, self.nyomorud1.transTime, dt, not self.nyomorud1Max); 
		setTranslation(self.nyomorud1.node, unpack(newTrans)); 
	end;
	
	local doRotate = self.kar2Max or self.kar2Min 
	if self.kar2 ~= nil and doRotate then
        	local x, y, z = getRotation(self.kar2.node);
        	local rot = {x,y,z};
        	local newRot = Utils.getMovedLimitedValues(rot, self.kar2.maxRot, self.kar2.minRot, 3, self.kar2.rotTime, dt, not self.kar2Max);
        	setRotation(self.kar2.node, unpack(newRot));
	end;
	
	local doRotate = self.csipeszMax or self.csipeszMin 
	if self.csipesz ~= nil and doRotate then
        	local x, y, z = getRotation(self.csipesz.node);
        	local rot = {x,y,z};
        	local newRot = Utils.getMovedLimitedValues(rot, self.csipesz.maxRot, self.csipesz.minRot, 3, self.csipesz.rotTime, dt, not self.csipeszMax);
        	setRotation(self.csipesz.node, unpack(newRot));
	end;
	
	if self.baltalp ~= nil then
        	local x, y, z = getRotation(self.baltalp.node);
        	local rot = {x,y,z};
        	local newRot = Utils.getMovedLimitedValues(rot, self.baltalp.maxRot, self.baltalp.minRot, 3, self.baltalp.rotTime, dt, not self.baltalpMax);
        	setRotation(self.baltalp.node, unpack(newRot));
	end;
	
	if self.talp ~= nil then
        	local x, y, z = getRotation(self.talp.node);
        	local rot = {x,y,z};
        	local newRot = Utils.getMovedLimitedValues(rot, self.talp.maxRot, self.talp.minRot, 3, self.talp.rotTime, dt, not self.talpMax);
        	setRotation(self.talp.node, unpack(newRot));
	end;
	
	if self.jobbtalp ~= nil then
        	local x, y, z = getRotation(self.jobbtalp.node);
        	local rot = {x,y,z};
        	local newRot = Utils.getMovedLimitedValues(rot, self.jobbtalp.maxRot, self.jobbtalp.minRot, 3, self.jobbtalp.rotTime, dt, not self.jobbtalpMax);
        	setRotation(self.jobbtalp.node, unpack(newRot));
	end;
	
	if self.talp1 ~= nil then
        	local x, y, z = getRotation(self.talp1.node);
        	local rot = {x,y,z};
        	local newRot = Utils.getMovedLimitedValues(rot, self.talp1.maxRot, self.talp1.minRot, 3, self.talp1.rotTime, dt, not self.talp1Max);
        	setRotation(self.talp1.node, unpack(newRot));
	end;
	
	local doTranslate = self.nyomorud2Max or self.nyomorud2Min 
	if self.nyomorud2 ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.nyomorud2.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.nyomorud2.maxTrans, self.nyomorud2.minTrans, 3, self.nyomorud2.transTime, dt, not self.nyomorud2Max); 
		setTranslation(self.nyomorud2.node, unpack(newTrans)); 
	end;
	
	if self.IranyjelzoLampaBal ~= nil then
            if self.iranyjelzoLampaBalActive then
            	setVisibility(self.IranyjelzoLampaBal, self.iranyjelzoLampaBalActive);
	    else
            	setVisibility(self.IranyjelzoLampaBal, self.iranyjelzoLampaBalActive);
	    end;
        end;

	if self.IranyjelzoLampaJobb ~= nil then
            if self.iranyjelzoLampaJobbActive then
            	setVisibility(self.IranyjelzoLampaJobb, self.iranyjelzoLampaJobbActive);
	    else
            	setVisibility(self.IranyjelzoLampaJobb, self.iranyjelzoLampaJobbActive);
	    end;
        end;

	if self.iranyjelzoBal then
		if self.kesleltetesBeBal >= -1 then
			self.kesleltetesBeBal = self.kesleltetesBeBal -dt;
		end;
		if not self.iranyjelzoLampaBalActive then
			if self.kesleltetesBeBal < 0 then
				self.kesleltetesKiBal = 500;
				self.iranyjelzoLampaBalActive = true;
				playSample(self.iranyjelzoHangId, 1, 0.7, 0);
			end;
		end;
		if self.kesleltetesKiBal >= 0 then
			self.kesleltetesKiBal = self.kesleltetesKiBal -dt;
		end;
		if self.iranyjelzoLampaBalActive then
			if self.kesleltetesKiBal < 0 then
				self.kesleltetesBeBal = 500;
				self.iranyjelzoLampaBalActive = false;
			end;
		end;
	end;

	if self.iranyjelzoJobb then
		if self.kesleltetesBeJobb >= 0 then
			self.kesleltetesBeJobb = self.kesleltetesBeJobb -dt;
		end;
		if not self.iranyjelzoLampaJobbActive then
			if self.kesleltetesBeJobb < 0 then
				self.kesleltetesKiJobb = 500;
				self.iranyjelzoLampaJobbActive = true;
				playSample(self.iranyjelzoHangId, 1, 0.7, 0);
			end;
		end;
		if self.kesleltetesKiJobb >= 0 then
			self.kesleltetesKiJobb = self.kesleltetesKiJobb -dt;
		end;
		if self.iranyjelzoLampaJobbActive then
			if self.kesleltetesKiJobb < 0 then
				self.kesleltetesBeJobb = 500;
				self.iranyjelzoLampaJobbActive = false;
			end;
		end;
	end;

	if self.iranyjelzo then
		if self.kesleltetesBe >= 0 then
			self.kesleltetesBe = self.kesleltetesBe -dt;
		end;
		if not self.iranyjelzoLampaJobbActive then
			if self.kesleltetesBe < 0 then
				self.kesleltetesKi = 500;
				self.iranyjelzoLampaJobbActive = true;
				self.iranyjelzoLampaBalActive = true;
				playSample(self.iranyjelzoHangId, 1, 0.7, 0);
			end;
		end;
		if self.kesleltetesKi >= 0 then
			self.kesleltetesKi = self.kesleltetesKi -dt;
		end;
		if self.iranyjelzoLampaJobbActive then
			if self.kesleltetesKi < 0 then
				self.kesleltetesBe = 500;
				self.iranyjelzoLampaBalActive = false;
				self.iranyjelzoLampaJobbActive = false;
			end;
		end;
	end;

	if not self.iranyjelzoBal and not self.iranyjelzoJobb then
		if not self.iranyjelzo then
			self.iranyjelzoLampaJobbActive = false;
			self.iranyjelzoLampaBalActive = false;
		end;
	end;
		
	if not self.iranyjelzo and not self.iranyjelzoBal then
		if not self.iranyjelzoJobb then
			self.iranyjelzoLampaJobbActive = false;
		end;
	end;

	if not self.iranyjelzo and not self.iranyjelzoJobb then
		if not self.iranyjelzoBal then
			self.iranyjelzoLampaBalActive = false;
		end;
	end;
	
	if self.isEntered then
      if self.rundumleuchtenAnz > 0 then
        if self.rundumleuchtenAn then
          for i=1, self.rundumleuchtenAnz do
          rotate(self.rundumleuchten[i].rotNode, 0, dt*self.rundumleuchten[i].speed, 0);
         end;
        end;
      end;
    end;

end;

function FortschrittT174:draw()

    if self.hudFortschrittT174Overlay ~= nil then
       if self.bcActive then
       self.hudFortschrittT174Overlay:render();
       end;  
    end;
    if self.bcActive then	
		g_currentMission:addExtraPrintText("Taste: O Info aus");
	else
		g_currentMission:addExtraPrintText("Taste: O Info an");
	end;
	 
	if self.motor.speedLevel ~= 0 then
            g_currentMission:addExtraPrintText("Motordrehzahl: "..string.format("%d RPM",self.motor.maxRpm[self.motor.speedLevel]).."");
	else
            g_currentMission:addExtraPrintText("Motordrehzahl: "..string.format("%d RPM",self.motor.maxRpm[3]).."");
	end;
end;

function FortschrittT174:onLeave()

    self.iranyjelzoLampaJobbActive = false;
    self.iranyjelzoLampaBalActive = false;
    self.iranyjelzo = false;
    self.iranyjelzoJobb = false;
    self.iranyjelzoBal = false;
	
    setVisibility(self.IranyjelzoLampaBal, self.iranyjelzoLampaBalActive);
    setVisibility(self.IranyjelzoLampaJobb, self.iranyjelzoLampaJobbActive);
	
	self.rundumleuchtenAn = false;
     for i=1, self.rundumleuchtenAnz do
       setVisibility(self.rundumleuchten[i].light, self.rundumleuchtenAn);
      end;
end;

function FortschrittT174:validateAttacherJoint(implement, jointDesc, dt)
    return true;
end;


















